package cn.com.qmth.stmms.biz.exam.bean;

import cn.com.qmth.stmms.biz.exam.model.ExamSubject;
import cn.com.qmth.stmms.biz.exam.model.Marker;
import cn.com.qmth.stmms.biz.user.model.User;
import cn.com.qmth.stmms.common.enums.MarkMode;
import io.swagger.annotations.ApiModelProperty;

public class MarkerInfo {

    @ApiModelProperty("评卷员id")
    private Integer id;

    @ApiModelProperty("")
    private Integer examId;

    @ApiModelProperty("")
    private String subjectCode;

    @ApiModelProperty("分组号")
    private Integer groupNumber;

    @ApiModelProperty("用户id")
    private Integer userId;

    @ApiModelProperty("启用禁用")
    private Boolean enable;

    @ApiModelProperty("评卷模式")
    private MarkMode mode;

    @ApiModelProperty("任务数")
    private Integer topCount;

    @ApiModelProperty("")
    private Integer finishCount;

    @ApiModelProperty("")
    private Integer validCount;

    @ApiModelProperty("")
    private Integer rejectCount;

    @ApiModelProperty("")
    private Double avgSpeed;

    @ApiModelProperty("")
    private Double avgScore;

    @ApiModelProperty("")
    private Double stdevScore;

    @ApiModelProperty("")
    private Integer finishCountNa;

    @ApiModelProperty("")
    private Integer validCountNa;

    @ApiModelProperty("")
    private Double avgSpeedNa;

    @ApiModelProperty("")
    private Double avgScoreNa;

    @ApiModelProperty("")
    private Double stdevScoreNa;

    /**
     * 个性化评卷参数设置
     */
    @ApiModelProperty("")
    private String markSetting;

    @ApiModelProperty("")
    private String subjectName;

    @ApiModelProperty("")
    private String groupName;

    @ApiModelProperty("登录名")
    private String loginName;

    @ApiModelProperty("")
    private ExamSubject subject;

    @ApiModelProperty("分组名")
    private String title;

    @ApiModelProperty("已评数量")
    private Long markedCount;

    @ApiModelProperty("")
    private Long markedCountNa;

    @ApiModelProperty("正在评卷")
    private Long currentCount;

    @ApiModelProperty("")
    private User user;

    @ApiModelProperty("")
    private Boolean reseting;

    /**
     * 班级数量
     */
    @ApiModelProperty("绑定班级")
    private Long classCount;

    @ApiModelProperty("")
    private Long arbitrateCount;

    @ApiModelProperty("")
    private String arbitrateRatio;

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public Integer getExamId() {
        return examId;
    }

    public void setExamId(Integer examId) {
        this.examId = examId;
    }

    public String getSubjectCode() {
        return subjectCode;
    }

    public void setSubjectCode(String subjectCode) {
        this.subjectCode = subjectCode;
    }

    public Integer getGroupNumber() {
        return groupNumber;
    }

    public void setGroupNumber(Integer groupNumber) {
        this.groupNumber = groupNumber;
    }

    public Integer getUserId() {
        return userId;
    }

    public void setUserId(Integer userId) {
        this.userId = userId;
    }

    public Boolean getEnable() {
        return enable;
    }

    public void setEnable(Boolean enable) {
        this.enable = enable;
    }

    public MarkMode getMode() {
        return mode;
    }

    public void setMode(MarkMode mode) {
        this.mode = mode;
    }

    public Integer getTopCount() {
        return topCount;
    }

    public void setTopCount(Integer topCount) {
        this.topCount = topCount;
    }

    public Integer getFinishCount() {
        return finishCount;
    }

    public void setFinishCount(Integer finishCount) {
        this.finishCount = finishCount;
    }

    public Integer getValidCount() {
        return validCount;
    }

    public void setValidCount(Integer validCount) {
        this.validCount = validCount;
    }

    public Integer getRejectCount() {
        return rejectCount;
    }

    public void setRejectCount(Integer rejectCount) {
        this.rejectCount = rejectCount;
    }

    public Double getAvgSpeed() {
        return avgSpeed;
    }

    public void setAvgSpeed(Double avgSpeed) {
        this.avgSpeed = avgSpeed;
    }

    public Double getAvgScore() {
        return avgScore;
    }

    public void setAvgScore(Double avgScore) {
        this.avgScore = avgScore;
    }

    public Double getStdevScore() {
        return stdevScore;
    }

    public void setStdevScore(Double stdevScore) {
        this.stdevScore = stdevScore;
    }

    public Integer getFinishCountNa() {
        return finishCountNa;
    }

    public void setFinishCountNa(Integer finishCountNa) {
        this.finishCountNa = finishCountNa;
    }

    public Integer getValidCountNa() {
        return validCountNa;
    }

    public void setValidCountNa(Integer validCountNa) {
        this.validCountNa = validCountNa;
    }

    public Double getAvgSpeedNa() {
        return avgSpeedNa;
    }

    public void setAvgSpeedNa(Double avgSpeedNa) {
        this.avgSpeedNa = avgSpeedNa;
    }

    public Double getAvgScoreNa() {
        return avgScoreNa;
    }

    public void setAvgScoreNa(Double avgScoreNa) {
        this.avgScoreNa = avgScoreNa;
    }

    public Double getStdevScoreNa() {
        return stdevScoreNa;
    }

    public void setStdevScoreNa(Double stdevScoreNa) {
        this.stdevScoreNa = stdevScoreNa;
    }

    public String getMarkSetting() {
        return markSetting;
    }

    public void setMarkSetting(String markSetting) {
        this.markSetting = markSetting;
    }

    public String getSubjectName() {
        return subjectName;
    }

    public void setSubjectName(String subjectName) {
        this.subjectName = subjectName;
    }

    public String getGroupName() {
        return groupName;
    }

    public void setGroupName(String groupName) {
        this.groupName = groupName;
    }

    public String getLoginName() {
        return loginName;
    }

    public void setLoginName(String loginName) {
        this.loginName = loginName;
    }

    public ExamSubject getSubject() {
        return subject;
    }

    public void setSubject(ExamSubject subject) {
        this.subject = subject;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public Long getMarkedCount() {
        return markedCount;
    }

    public void setMarkedCount(Long markedCount) {
        this.markedCount = markedCount;
    }

    public Long getMarkedCountNa() {
        return markedCountNa;
    }

    public void setMarkedCountNa(Long markedCountNa) {
        this.markedCountNa = markedCountNa;
    }

    public Long getCurrentCount() {
        return currentCount;
    }

    public void setCurrentCount(Long currentCount) {
        this.currentCount = currentCount;
    }

    public User getUser() {
        return user;
    }

    public void setUser(User user) {
        this.user = user;
    }

    public Boolean getReseting() {
        return reseting;
    }

    public void setReseting(Boolean reseting) {
        this.reseting = reseting;
    }

    public Long getClassCount() {
        return classCount;
    }

    public void setClassCount(Long classCount) {
        this.classCount = classCount;
    }

    public Long getArbitrateCount() {
        return arbitrateCount;
    }

    public void setArbitrateCount(Long arbitrateCount) {
        this.arbitrateCount = arbitrateCount;
    }

    public String getArbitrateRatio() {
        return arbitrateRatio;
    }

    public void setArbitrateRatio(String arbitrateRatio) {
        this.arbitrateRatio = arbitrateRatio;
    }

    public static MarkerInfo of(Marker from) {
        if (from == null) {
            return null;
        }
        MarkerInfo ret = new MarkerInfo();
        ret.setId(from.getId());
        ret.setExamId(from.getExamId());
        ret.setSubjectCode(from.getSubjectCode());
        ret.setGroupNumber(from.getGroupNumber());
        ret.setUserId(from.getUserId());
        ret.setEnable(from.isEnable());
        ret.setMode(from.getMode());
        ret.setTopCount(from.getTopCount());
        ret.setFinishCount(from.getFinishCount());
        ret.setValidCount(from.getValidCount());
        ret.setRejectCount(from.getRejectCount());
        ret.setAvgSpeed(from.getAvgSpeed());
        ret.setAvgScore(from.getAvgScore());
        ret.setStdevScore(from.getStdevScore());
        ret.setFinishCountNa(from.getFinishCountNa());
        ret.setValidCountNa(from.getValidCountNa());
        ret.setAvgSpeedNa(from.getAvgSpeedNa());
        ret.setAvgScoreNa(from.getAvgScoreNa());
        ret.setStdevScoreNa(from.getStdevScoreNa());
        ret.setMarkSetting(from.getMarkSetting());
        ret.setSubjectName(from.getSubjectName());
        ret.setGroupName(from.getGroupName());
        ret.setLoginName(from.getLoginName());
        ret.setSubject(from.getSubject());
        ret.setTitle(from.getGroup().getTitle());
        ret.setMarkedCount(from.getMarkedCount());
        ret.setMarkedCountNa(from.getMarkedCountNa());
        ret.setCurrentCount(from.getCurrentCount());
        ret.setUser(from.getUser());
        ret.setReseting(from.isReseting());
        ret.setClassCount(from.getClassCount());
        ret.setArbitrateCount(from.getArbitrateCount());
        ret.setArbitrateRatio(from.getArbitrateRatio());
        return ret;
    }
}
