package cn.com.qmth.stmms.biz.exam.bean;

import cn.com.qmth.stmms.biz.exam.model.ExamSubject;
import cn.com.qmth.stmms.biz.exam.model.MarkGroup;
import cn.com.qmth.stmms.biz.exam.model.Marker;
import cn.com.qmth.stmms.biz.utils.Calculator;
import cn.com.qmth.stmms.common.annotation.ExcelField;
import cn.com.qmth.stmms.common.enums.MarkMode;
import io.swagger.annotations.ApiModelProperty;

public class MarkerQualityVo {

    @ApiModelProperty("评卷员id")
    private Integer id;

    @ApiModelProperty("")
    private Integer examId;

    @ApiModelProperty("")
    private String subjectCode;

    private Integer groupNumber;

    @ApiModelProperty("用户id")
    private Integer userId;

    @ApiModelProperty("启用禁用")
    private Boolean enable;

    @ApiModelProperty("评卷模式")
    private MarkMode mode;

    @ApiModelProperty("任务数")
    private Integer topCount;

    @ExcelField(title = "分组", align = 2, sort = 10)
    @ApiModelProperty("分组")
    private String groupText;

    @ExcelField(title = "评卷员", align = 2, sort = 20)
    @ApiModelProperty("评卷员")
    private String loginName;

    @ExcelField(title = "姓名", align = 2, sort = 30)
    @ApiModelProperty("姓名")
    private String name;

    @ApiModelProperty("")
    private ExamSubject subject;

    private String title;

    @ApiModelProperty("已评数量")
    private Long markedCount;

    @ApiModelProperty("")
    private Long markedCountNa;

    @ApiModelProperty("正在评卷")
    private Long currentCount;

    @ApiModelProperty("是否正在重置")
    private Boolean reseting;

    /**
     * 班级数量
     */
    @ApiModelProperty("绑定班级")
    private Long classCount;

    @ExcelField(title = "完成任务数", align = 2, sort = 40)
    @ApiModelProperty("完成任务数")
    private Integer finishCount;

    private Integer validCount;

    @ApiModelProperty(hidden = true)
    private Integer finishCountNa;

    @ApiModelProperty(hidden = true)
    private Integer validCountNa;

    @ApiModelProperty(hidden = true)
    private Double avgSpeedNa;

    @ApiModelProperty(hidden = true)
    private Double avgScoreNa;

    @ApiModelProperty(hidden = true)
    private Double stdevScoreNa;

    // 待仲裁数
    @ApiModelProperty(hidden = true)
    private Integer waitArbitrateCount;

    /**
     * 个性化评卷参数设置
     */
    @ApiModelProperty(hidden = true)
    private String markSetting;

    @ApiModelProperty(hidden = true)
    private String subjectName;

    @ApiModelProperty(hidden = true)
    private String groupName;

    @ApiModelProperty(hidden = true)
    private MarkGroup group;

    @ExcelField(title = "仲裁任务数", align = 2, sort = 50)
    @ApiModelProperty("仲裁任务数")
    private long arbitrateCount;

    @ExcelField(title = "仲裁率", align = 2, sort = 60)
    @ApiModelProperty("仲裁率")
    private String arbitrateRatio;

    @ExcelField(title = "打回次数", align = 2, sort = 70)
    @ApiModelProperty("打回次数")
    private Integer rejectCount;

    @ExcelField(title = "评卷采用率", align = 2, sort = 80)
    @ApiModelProperty("评卷采用率")
    private String markValidRatio;

    @ExcelField(title = "评卷速度(秒)", align = 2, sort = 90)
    @ApiModelProperty("评卷速度(秒)")
    private Double avgSpeed;

    @ExcelField(title = "平均分", align = 2, sort = 100)
    @ApiModelProperty("平均分")
    private Double avgScore;

    @ExcelField(title = "标准差", align = 2, sort = 110)
    @ApiModelProperty("标准差")
    private Double stdevScore;

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public Integer getExamId() {
        return examId;
    }

    public void setExamId(Integer examId) {
        this.examId = examId;
    }

    public String getSubjectCode() {
        return subjectCode;
    }

    public void setSubjectCode(String subjectCode) {
        this.subjectCode = subjectCode;
    }

    public Integer getGroupNumber() {
        return groupNumber;
    }

    public void setGroupNumber(Integer groupNumber) {
        this.groupNumber = groupNumber;
    }

    public Integer getUserId() {
        return userId;
    }

    public void setUserId(Integer userId) {
        this.userId = userId;
    }

    public Boolean getEnable() {
        return enable;
    }

    public void setEnable(Boolean enable) {
        this.enable = enable;
    }

    public MarkMode getMode() {
        return mode;
    }

    public void setMode(MarkMode mode) {
        this.mode = mode;
    }

    public Integer getTopCount() {
        return topCount;
    }

    public void setTopCount(Integer topCount) {
        this.topCount = topCount;
    }

    public String getLoginName() {
        return loginName;
    }

    public void setLoginName(String loginName) {
        this.loginName = loginName;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public ExamSubject getSubject() {
        return subject;
    }

    public void setSubject(ExamSubject subject) {
        this.subject = subject;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public Long getMarkedCount() {
        return markedCount;
    }

    public void setMarkedCount(Long markedCount) {
        this.markedCount = markedCount;
    }

    public Long getMarkedCountNa() {
        return markedCountNa;
    }

    public void setMarkedCountNa(Long markedCountNa) {
        this.markedCountNa = markedCountNa;
    }

    public Long getCurrentCount() {
        return currentCount;
    }

    public void setCurrentCount(Long currentCount) {
        this.currentCount = currentCount;
    }

    public Boolean getReseting() {
        return reseting;
    }

    public void setReseting(Boolean reseting) {
        this.reseting = reseting;
    }

    public Long getClassCount() {
        return classCount;
    }

    public void setClassCount(Long classCount) {
        this.classCount = classCount;
    }

    public Integer getFinishCount() {
        return finishCount;
    }

    public void setFinishCount(Integer finishCount) {
        this.finishCount = finishCount;
    }

    public Integer getValidCount() {
        return validCount;
    }

    public void setValidCount(Integer validCount) {
        this.validCount = validCount;
    }

    public Integer getRejectCount() {
        return rejectCount;
    }

    public void setRejectCount(Integer rejectCount) {
        this.rejectCount = rejectCount;
    }

    public Double getAvgSpeed() {
        return avgSpeed;
    }

    public void setAvgSpeed(Double avgSpeed) {
        this.avgSpeed = avgSpeed;
    }

    public Double getAvgScore() {
        return avgScore;
    }

    public void setAvgScore(Double avgScore) {
        this.avgScore = avgScore;
    }

    public Double getStdevScore() {
        return stdevScore;
    }

    public void setStdevScore(Double stdevScore) {
        this.stdevScore = stdevScore;
    }

    public Integer getFinishCountNa() {
        return finishCountNa;
    }

    public void setFinishCountNa(Integer finishCountNa) {
        this.finishCountNa = finishCountNa;
    }

    public Integer getValidCountNa() {
        return validCountNa;
    }

    public void setValidCountNa(Integer validCountNa) {
        this.validCountNa = validCountNa;
    }

    public Double getAvgSpeedNa() {
        return avgSpeedNa;
    }

    public void setAvgSpeedNa(Double avgSpeedNa) {
        this.avgSpeedNa = avgSpeedNa;
    }

    public Double getAvgScoreNa() {
        return avgScoreNa;
    }

    public void setAvgScoreNa(Double avgScoreNa) {
        this.avgScoreNa = avgScoreNa;
    }

    public Double getStdevScoreNa() {
        return stdevScoreNa;
    }

    public void setStdevScoreNa(Double stdevScoreNa) {
        this.stdevScoreNa = stdevScoreNa;
    }

    public Integer getWaitArbitrateCount() {
        return waitArbitrateCount;
    }

    public void setWaitArbitrateCount(Integer waitArbitrateCount) {
        this.waitArbitrateCount = waitArbitrateCount;
    }

    public String getMarkSetting() {
        return markSetting;
    }

    public void setMarkSetting(String markSetting) {
        this.markSetting = markSetting;
    }

    public String getSubjectName() {
        return subjectName;
    }

    public void setSubjectName(String subjectName) {
        this.subjectName = subjectName;
    }

    public String getGroupName() {
        return groupName;
    }

    public void setGroupName(String groupName) {
        this.groupName = groupName;
    }

    public MarkGroup getGroup() {
        return group;
    }

    public void setGroup(MarkGroup group) {
        this.group = group;
    }

    public long getArbitrateCount() {
        return arbitrateCount;
    }

    public void setArbitrateCount(long arbitrateCount) {
        this.arbitrateCount = arbitrateCount;
    }

    public String getArbitrateRatio() {
        return arbitrateRatio;
    }

    public void setArbitrateRatio(String arbitrateRatio) {
        this.arbitrateRatio = arbitrateRatio;
    }

    public String getMarkValidRatio() {
        return markValidRatio;
    }

    public void setMarkValidRatio(String markValidRatio) {
        this.markValidRatio = markValidRatio;
    }

    public String getGroupText() {
        return groupText;
    }

    public void setGroupText(String groupText) {
        this.groupText = groupText;
    }

    public static MarkerQualityVo of(Marker from) {
        if (from == null) {
            return null;
        }
        MarkerQualityVo ret = new MarkerQualityVo();
        ret.setId(from.getId());
        ret.setExamId(from.getExamId());
        ret.setSubjectCode(from.getSubjectCode());
        ret.setGroupNumber(from.getGroupNumber());
        ret.setUserId(from.getUserId());
        ret.setEnable(from.isEnable());
        ret.setMode(from.getMode());
        ret.setTopCount(from.getTopCount());
        ret.setLoginName(from.getLoginName());
        ret.setSubject(from.getSubject());
        ret.setTitle(from.getGroup().getTitle());
        ret.setMarkedCount(from.getMarkedCount());
        ret.setMarkedCountNa(from.getMarkedCountNa());
        ret.setCurrentCount(from.getCurrentCount());
        ret.setReseting(from.isReseting());
        ret.setClassCount(from.getClassCount());
        ret.setFinishCount(from.getFinishCount());
        ret.setValidCount(from.getValidCount());
        ret.setRejectCount(from.getRejectCount());
        ret.setAvgSpeed(from.getAvgSpeed());
        ret.setAvgScore(from.getAvgScore());
        ret.setStdevScore(from.getStdevScore());
        ret.setFinishCountNa(from.getFinishCountNa());
        ret.setValidCountNa(from.getValidCountNa());
        ret.setAvgSpeedNa(from.getAvgSpeedNa());
        ret.setAvgScoreNa(from.getAvgScoreNa());
        ret.setStdevScoreNa(from.getStdevScoreNa());
        ret.setWaitArbitrateCount(from.getWaitArbitrateCount());
        ret.setMarkSetting(from.getMarkSetting());
        ret.setSubjectName(from.getSubjectName());
        ret.setGroupName(from.getGroupName());
        ret.setGroup(from.getGroup());
        ret.setArbitrateCount(from.getArbitrateCount());
        ret.setArbitrateRatio(from.getArbitrateRatio());
        if (from.getFinishCount() != null && from.getRejectCount() != null && from.getFinishCount() > 0
                && (from.getFinishCount() - from.getRejectCount()) > 0) {
            ret.setMarkValidRatio(
                    Calculator.percentage(from.getFinishCount() - from.getRejectCount(), from.getFinishCount(), 3));
        } else if ((from.getRejectCount() == null || from.getRejectCount() == 0) && from.getFinishCount() != null) {
            ret.setMarkValidRatio("100%");
        } else {
            ret.setMarkValidRatio("0%");
        }
        ret.setName(from.getUser().getName());
        ret.setGroupText(ret.getGroupNumber() + "-" + ret.getTitle());
        return ret;
    }
}
