package cn.com.qmth.stmms.biz.exam.query;

import org.springframework.data.domain.Sort;
import org.springframework.data.domain.Sort.Direction;

import cn.com.qmth.stmms.biz.common.BaseQuery;
import cn.com.qmth.stmms.biz.exam.model.Marker;
import io.swagger.annotations.ApiModelProperty;

public class MarkerSearchQuery extends BaseQuery<Marker> {

    @ApiModelProperty(hidden = true)
    private Integer id;

    @ApiModelProperty(hidden = true)
    private Integer examId;

    @ApiModelProperty("科目代码")
    private String subjectCode;

    @ApiModelProperty("分组号")
    private Integer groupNumber;

    @ApiModelProperty("登录名")
    private String loginName;

    @ApiModelProperty("姓名")
    private String name;

    @ApiModelProperty(hidden = true)
    private String subjectCodeIn;

    @ApiModelProperty("已评卷")
    private Boolean marked;

    @ApiModelProperty("不含仲裁")
    private Boolean noArbitrate;

    public void orderById() {
        setSort(new Sort(Direction.ASC, "id"));
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public Integer getExamId() {
        return examId;
    }

    public void setExamId(Integer examId) {
        this.examId = examId;
    }

    public String getSubjectCode() {
        return subjectCode;
    }

    public void setSubjectCode(String subjectCode) {
        this.subjectCode = subjectCode;
    }

    public Integer getGroupNumber() {
        return groupNumber;
    }

    public void setGroupNumber(Integer groupNumber) {
        this.groupNumber = groupNumber;
    }

    public String getLoginName() {
        return loginName;
    }

    public void setLoginName(String loginName) {
        this.loginName = loginName;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getSubjectCodeIn() {
        return subjectCodeIn;
    }

    public void setSubjectCodeIn(String subjectCodeIn) {
        this.subjectCodeIn = subjectCodeIn;
    }

    public Boolean getMarked() {
        return marked;
    }

    public void setMarked(Boolean marked) {
        this.marked = marked;
    }

    public Boolean getNoArbitrate() {
        return noArbitrate;
    }

    public void setNoArbitrate(Boolean noArbitrate) {
        this.noArbitrate = noArbitrate;
    }

}
